//
//  ConversationsViewController.swift
//  VKExt
//
//  Created programmist_NA on 20.05.2020.
//  Copyright © 2020 ___ORGANIZATIONNAME___. All rights reserved.
//
//  Template generated by Juanpe Catalán @JuanpeCMiOS
//

import UIKit
import Material
import MaterialComponents
import SwiftMessages
import SwiftyVK
import RealmSwift
import LocalAuthentication
import EasyTipView

var privateConversationsCount = try! Realm().objects(Conversation.self).filter("isPrivateConversation = %@", true).count

class ConversationsViewController: UIBaseTableViewController, UIBaseViewControllerProtocol, UIBaseTableViewControllerProtocol, ConversationsViewProtocol {
	var presenter: ConversationsPresenterProtocol?
    var token: NotificationToken?
    lazy var realm = try! Realm()
    var conversations = try! Realm().objects(Conversation.self).sorted(byKeyPath: "dateInteger", ascending: false).sorted(byKeyPath: "isImportantDialog", ascending: false).filter("isPrivateConversation = %@", false)
    var createConversationButton: IconButton = {
        let button = IconButton(image: UIImage(named: "write_square_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        return button
    }()
    var privateConversations: IconButton = {
        let button = IconButton(image: UIImage(named: "privacy_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue), tintColor: .adaptableBlue)
        button.addTarget(self, action: #selector(openPrivateConversations), for: .touchUpInside)
        return button
    }()
    let searchTable = UITableView(frame: .zero, style: .plain)
    var searchController: VKSearchBar = VKSearchBar(frame: CGRect(origin: .zero, size: CGSize(width: Screen.bounds.width, height: 52)))
    var isSearch: Bool = false
    let activityIndicator = MDCActivityIndicator()
    var dialogTransitionController: MDCDialogTransitionController!
    var dialogViewController: MDCAlertController!
    var timeHide = 0.0
    let context = LAContext()

    deinit {
        print("Conversations deinited")
        token?.invalidate()
        NotificationCenter.default.removeObserver(self)
    }

	override func viewDidLoad() {
        super.viewDidLoad()
        navigationItem.titleLabel.text = "Сообщения"
        ConversationsRouter.createModule(self)
        presenter?.start()
        initialObservers()
        prepareToolbar(fonts: [GoogleSansFont.bold(with: 21), GoogleSansFont.regular(with: 13)])
        setupToolbar(title: "Сообщения", subtitle: "", leftViews: privateConversationsCount > 0 ? [privateConversations] : nil, rightViews: [createConversationButton])
        initialComponent()
        setupTable()
        
        if privateConversationsCount > 0 {
            self.toolbar.leftViews = [self.privateConversations]
        } else {
            self.toolbar.leftViews = []
        }
        
        if realm.objects(Conversation.self).filter("interlocutorName == %@", "#extended_test").first != nil && UIApplication.isFirstLaunch {
            self.showStatusError(message: "Вы подключены к беседе #extended_test", .success)
        }
        observeConversations()
    }
    
    override func viewWillAppear(_ animated: Bool) {
        super.viewWillAppear(animated)
        initialObservers()
        observeConversations()
    }
    
    override func viewWillDisappear(_ animated: Bool) {
        super.viewWillDisappear(animated)
        token?.invalidate()
        NotificationCenter.default.removeObserver(self)
    }
    
    // Отслеживание изменения цветосхемы
    override func traitCollectionDidChange(_ previousTraitCollection: UITraitCollection?) {
        if previousTraitCollection?.userInterfaceStyle == .light {
            activityIndicator.cycleColors = [.adaptableBlack]
        } else {
            activityIndicator.cycleColors = [.extendedBlue]
        }
        privateConversations.image = UIImage(named: "privacy_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue)
        createConversationButton.image = UIImage(named: "write_square_outline_28")?.withRenderingMode(.alwaysTemplate).tint(with: .adaptableBlue)
    }
    
    //
    func observeConversations() {
        token = conversations.observe { [weak mainTable] changes in
            guard let tableView = mainTable else { return }
            
            switch changes {
            case .initial:
                tableView.reloadData()
            case .update(_, let deletions, let insertions, let updates):
                tableView.applyChanges(with: deletions, with: insertions, with: updates, at: 0)
            case .error: break
            }
        }
    }
    
    // Инициализация обсерверов
    func initialObservers() {
        NotificationCenter.default.addObserver(self, selector: #selector(didRefreshed), name: NSNotification.Name(rawValue: "Refreshed"), object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(willVKSearchBarOpened), name: NSNotification.Name(rawValue: "VKSearchBar.beginEditing"), object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(willVKSearchBarClosed), name: NSNotification.Name(rawValue: "VKSearchBar.endEditing"), object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(willReadMessage), name: .showMessage, object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(onLackOfPrivate), name: NSNotification.Name(rawValue: "noPrivateConversations"), object: nil)
        NotificationCenter.default.addObserver(self, selector: #selector(onPrivatePresence), name: NSNotification.Name(rawValue: "privateConversations"), object: nil)
    }
    
    // Настройка диалогового окна
    func settingDialog(title: String, message: String, okTitle: String? = nil, cancelTitle: String? = nil, okHandler: (() -> ())? = nil, cancelHandler: (() -> ())? = nil) {
        dialogTransitionController = MDCDialogTransitionController()
        dialogViewController = MDCAlertController(title: title, message: message)
        dialogViewController.titleFont = GoogleSansFont.medium(with: 18)
        dialogViewController.messageFont = GoogleSansFont.regular(with: 16)
        dialogViewController.backgroundColor = .adaptableWhite
        dialogViewController.titleColor = .adaptableBlack
        dialogViewController.messageColor = UIColor.adaptableBlack.withAlphaComponent(0.5)
        
        if let okTitle = okTitle {
            let confrim = MDCAlertAction(title: okTitle) { [weak self] (action) in
                guard let self = self else { return }
                self.dialogViewController.dismiss(animated: true, completion: {
                    guard let handler = okHandler else { return }
                    handler()
                })
            }
            dialogViewController.addAction(confrim)
            dialogViewController.button(for: confrim)?.setTitleFont(GoogleSansFont.medium(with: 10), for: .normal)
            dialogViewController.button(for: confrim)?.setTitleColor(.extendedBlue, for: .normal)
        }
        if let cancelTitle = cancelTitle {
            let cancel = MDCAlertAction(title: cancelTitle) { [weak self] (action) in
                guard let self = self else { return }
                self.dialogViewController.dismiss(animated: true, completion: {
                    guard let handler = cancelHandler else { return }
                    handler()
                })
            }
            dialogViewController.addAction(cancel)
            dialogViewController.button(for: cancel)?.setTitleFont(GoogleSansFont.medium(with: 10), for: .normal)
            dialogViewController.button(for: cancel)?.setTitleColor(.adaptableBlack, for: .normal)
        }
        dialogViewController.cornerRadius = 16
        present(dialogViewController, animated: true, completion: nil)
    }
    
    // Настройка компонентов
    func initialComponent() {
        // Progress indicator
        activityIndicator.sizeToFit()
        view.addSubview(activityIndicator)
        activityIndicator.autoCenterInSuperview()
        activityIndicator.radius = 15
        activityIndicator.strokeWidth = 3
        activityIndicator.indicatorMode = .indeterminate
        activityIndicator.cycleColors = [.extendedBlue]
        activityIndicator.isHidden = true
    }
    
    // Настройка тулбара (протокол)
    func setupToolbar(title: String, subtitle: String, leftViews: [UIView]?, rightViews: [UIView]?) {
        toolbar.title = title
        toolbar.detail = subtitle
        if let leftViews = leftViews {
            toolbar.leftViews = leftViews
        }
        if let rightViews = rightViews {
            toolbar.rightViews = rightViews
        }
        let tapRecognizer: UITapGestureRecognizer = UITapGestureRecognizer(target: self, action: #selector(showMenu))
        tapRecognizer.numberOfTapsRequired = 1
        toolbar.titleLabel.isUserInteractionEnabled = true
        toolbar.titleLabel.addGestureRecognizer(tapRecognizer)
    }
    
    // Настройка таблицы
    func setupTable() {
        if conversations.isEmpty {
            mainTable.isHidden = true
        }
        mainTable.keyboardDismissMode = .onDrag
        mainTable.allowsMultipleSelection = false
        mainTable.allowsMultipleSelectionDuringEditing = true
        mainTable.separatorStyle = .none
        mainTable.delegate = self
        mainTable.dataSource = self
        mainTable.register(UINib(nibName: "MessageViewCell", bundle: nil), forCellReuseIdentifier: "MessageViewCell")
        mainTable.tableHeaderView = searchController
        let longPressGestureRecognizer = UILongPressGestureRecognizer(target: self, action: #selector(handleLongPress(_:)))
        longPressGestureRecognizer.minimumPressDuration = 0.25
        mainTable.addGestureRecognizer(longPressGestureRecognizer)
        searchController.setup(placeholder: "Поиск")
        searchController.textView.delegate = self
        refreshControl.removeFromSuperview()
        // refreshControl.addTarget(self, action: #selector(refreshTable(_:)), for: .valueChanged)
    }
    
    func initialFooter() {
        
    }
    
    // Наличие загрузочного индикатора
    func availabilityLoader(hasNeed: Bool) {
        if hasNeed {
            activityIndicator.isHidden = false
            mainTable.isHidden = true
            activityIndicator.startAnimating()
        } else {
            activityIndicator.isHidden = true
            mainTable.isHidden = false
            activityIndicator.stopAnimating()
        }
    }
    
    // Окончание загрузки
    func finishLoading() {
        refreshControl.endRefreshing()
        mainTable.reloadData()
    }
    
    // Окончание поиска
    func finishSearch() {
        searchTable.reloadData()
    }
    
    @objc func showMenu() {
        print(#function)
        let item1 = DropdownItem(image: UIImage(named: "message_unread_outline_28")!, title: "Непрочитанные")
        let item2 = DropdownItem(image: UIImage(named: "messages_outline_28 @ chats")!, title: "Все")

        let items = [item1, item2]
        let menuView = DropdownMenu(navigationController: self.navigationController!, items: items)
        menuView.delegate = self
        menuView.showMenu()
    }
    
    // Уведомление о подключении к LongPoll
    @objc func didRefreshed(_ notification: Notification) {
        DispatchQueue.main.async {
            self.animateToolbarSubTitle("Подключено")
        }
    }
    
    // Принудительное обновление
    @objc func refreshTable(_ sender: Any?) {
//        self.presenter?.start(hasNeedPreloader: false)
    }
    
    // Обработка долгого нажатия на диалог
    @objc func handleLongPress(_ gestureRecognizer: UILongPressGestureRecognizer?) {
        guard let point = gestureRecognizer?.location(in: self.mainTable) else { return }
        let indexPath = self.mainTable.indexPathForRow(at: point)
        if indexPath == nil {
            print("Long press on table view, not row.")
        } else if gestureRecognizer?.state == .began {
            let conversation = self.conversations[indexPath!.row]
            let messagesCount = conversation.unreadCount
            let message = messagesCount == 0 ? "Нет новых сообщений" : "\(conversation.unreadCount) \(getStringByDeclension(number: conversation.unreadCount, arrayWords: Localization.instance.newMessagesCount))"
            self.initialActionSheet(title: conversation.interlocutorName, message: message, actions: self.getActions(at: conversation, from: indexPath!))
        }
    }
    
    // Анимация подъема при открытии поиска
    @objc func willVKSearchBarOpened(_ notification: Notification) {
        let transfrom = CGAffineTransform.identity
        UIView.animate(withDuration: 0.3, animations: {
            self.toolbar.alpha = 0
            self.view.transform = transfrom.translatedBy(x: 0, y: -56)
            self.view.layoutIfNeeded()
        }) { _ in
            self.toolbar.isHidden = true
        }
    }
    
    // Анимация опускания при закрытии поиска
    @objc func willVKSearchBarClosed(_ notification: Notification) {
        self.toolbar.isHidden = false
        UIView.animate(withDuration: 0.3, animations: {
            self.toolbar.alpha = 1
            self.searchTable.alpha = 0
            self.view.transform = .identity
            self.view.layoutIfNeeded()
        }) { _ in
            self.searchTable.isHidden = true
        }
    }
    
    // Уведомление о прочитке сообщения
    @objc func willReadMessage(_ notification: Notification) {
        let message = notification.userInfo?["readMessage"] as! String
        self.showStatusError(message: message, .normal)
    }
    
    // Уведомление о наличии скрытых
    @objc func onPrivatePresence(_ notification: Notification) {
        guard toolbar.leftViews == [] else { return }
        toolbar.leftViews = [privateConversations]
        EasyTipView.show(forView: toolbar.leftViews.first!, text: "Ваши скрытые переписки здесь", preferences: self.preferences)
    }
    
    // Уведомление об отсутствии скрытых
    @objc func onLackOfPrivate(_ notification: Notification) {
        guard toolbar.leftViews == [privateConversations] else { return }
        toolbar.leftViews = []
    }
    
    // Открытие приватных сообщений
    @objc func openPrivateConversations(_ sender: IconButton) {
        let privateController = PrivateConversationsViewController()
        self.authenticateUser(completion: { [weak self] in
            guard let self = self else { return }
            self.presentPanModal(privateController)
        }) { [weak self] message in
            guard let self = self, let message = message else { return }
            self.settingDialog(title: "Ошибка", message: message, okTitle: nil, cancelTitle: "Закрыть", okHandler: {
                return
            }) { [weak self] in
                self?.dialogViewController.dismiss(animated: true, completion: nil)
            }
        }
    }
}
extension ConversationsViewController {
    // Получение доступных с диалогом действий
    func getActions(at conversation: Conversation, from indexPath: IndexPath) -> [MDCActionSheetAction] {
        guard let presenter = self.presenter else { return [] }
        let setImportantStatus = MDCActionSheetAction(title: !conversation.isImportantDialog ? "Пометить избранным" : "Убрать пометку избранного", image: UIImage(named: conversation.isImportantDialog ? "unfavorite_outline_28" : "favorite_outline_28"), handler: { action in
            let realm = try! Realm()
            UserDefaults.standard.set(!conversation.isImportantDialog, forKey: "importantState_from_\(conversation.peerId)")
            ConversationService.instance.setHiddenKey(key: "importantState_from_\(conversation.peerId)", value: "\(!conversation.isImportantDialog)")
            realm.beginWrite()
            conversation.isImportantDialog = !conversation.isImportantDialog
            try! realm.commitWrite()
        })
        let snooze = MDCActionSheetAction(title: conversation.disabledForever ? "Включить уведомления" : "Отключить уведомления", image: UIImage(named: conversation.disabledForever ? "notification_outline_28" : "notification_disable_outline_28"), handler: { action in
            presenter.onChangeSilenceMode(peerId: conversation.peerId, sound: (!conversation.disabledForever).intValue)
        })
        let readConversation = MDCActionSheetAction(title: "Прочитать сообщения", image: UIImage(named: "view_outline_28"), handler: { action in
            presenter.onTapReadConversation(at: indexPath)
        })
        let unreadConversation = MDCActionSheetAction(title: "Пометить непрочитанным", image: UIImage(named: "view_outline_28"), handler: { [weak self] action in
            guard let self = self else { return }
            if !UIApplication.isFirstLaunch {
                self.settingDialog(title: "Принцип работы", message: "Эта пометка видима только Вам, и нужна лишь для накрутки значения на счетчик", okTitle: "Понятно", okHandler: {
                    presenter.onTapUnreadConversation(at: indexPath)
                })
            } else {
                presenter.onTapUnreadConversation(at: indexPath)
            }
        })
        let performProfile = MDCActionSheetAction(title: "Перейти в профиль", image: UIImage(named: "user_outgoing_outline_28"), handler: { [weak self] action in
            guard let self = self else { return }
            let userId = conversation.peerId
            self.presenter?.onTapPerformProfile(userId: userId)
        })
        let enableAggressiveTyping = MDCActionSheetAction(title: "Агрессивный тайпинг", image: UIImage(named: "list_add_outline_28"), handler: { action in
            ConversationService.instance.getHiddenKey(keys: ["conversation_from\(conversation.peerId)"]) { (values) in
                print(values)
            }
        })
        let disableAggressiveTyping = MDCActionSheetAction(title: "Отключить агрессивный тайпинг", image: UIImage(named: "list_add_outline_28"), handler: { action in
            
        })
        let hideConversation = MDCActionSheetAction(title: "Скрыть переписку", image: UIImage(named: "privacy_outline_28"), handler: { action in
            let realm = try! Realm()
            UserDefaults.standard.set(true, forKey: "private_conversation_from\(conversation.peerId)")
            ConversationService.instance.setHiddenKey(key: "private_conversation_from\(conversation.peerId)", value: "true")
            realm.beginWrite()
            conversation.isPrivateConversation = true
            try! realm.commitWrite()
            NotificationCenter.default.post(name: NSNotification.Name("privateConversations"), object: nil)
        })
        let removeConversation = MDCActionSheetAction(title: "Удалить переписку", image: UIImage(named: "delete_outline_28"), handler: { [weak self] action in
            guard let self = self else { return }
            self.settingDialog(title: "Удаление диалога", message: "Вы точно хотите удалить диалог?", okTitle: "Да", cancelTitle: " Отмена", okHandler: {
                presenter.onDeleteConversation(peerId: conversation.peerId)
            }) {
                self.dialogViewController.dismiss(animated: true, completion: nil)
            }
        })
        removeConversation.titleColor = .extendedRed
        removeConversation.tintColor = .extendedRed
        var actions: [MDCActionSheetAction]
        if conversation.unreadStatus == .unreadIn || conversation.unreadStatus == .markedUnread {
            actions = [setImportantStatus, readConversation, snooze, performProfile, conversation.isAggressiveTypingActive ? disableAggressiveTyping : enableAggressiveTyping, hideConversation, removeConversation]
        } else if conversation.unreadStatus != .markedUnread && !conversation.isOutgoing {
            actions = [setImportantStatus, unreadConversation, snooze, performProfile, conversation.isAggressiveTypingActive ? disableAggressiveTyping : enableAggressiveTyping, hideConversation, removeConversation]
        } else {
            actions = [setImportantStatus, snooze, performProfile, conversation.isAggressiveTypingActive ? disableAggressiveTyping : enableAggressiveTyping, hideConversation, removeConversation]
        }
        
        return actions
    }
}
extension ConversationsViewController: UITableViewDelegate, UITableViewDataSource {
    func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int {
        guard let presenter = presenter else { return 0 }
        return isSearch ? presenter.searchConversations.count : conversations.count
    }
    
    func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell {
        guard let presenter = presenter else { return UITableViewCell() }
        let cell = tableView.dequeueReusableCell(withIdentifier: "MessageViewCell", for: indexPath) as! MessageViewCell
        cell.alternativeSetup(conversation: isSearch ? presenter.searchConversations[indexPath.row] : conversations[indexPath.row])
        cell.delegate = self
        cell.selectionStyle = .none
        return cell
    }
    
    func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat {
        return 72
    }
    
    func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath) {
        if !tableView.isEditing {
            tableView.deselectRow(at: indexPath, animated: false)
            guard let presenter = presenter else { return }
            presenter.onTapConversation(at: indexPath)
        } else {
            let cell = tableView.cellForRow(at: indexPath) as? MessageViewCell
            cell?.isSelected = true
            cell?.setSelected(true, animated: true)
        }
    }
    
    func numberOfSections(in tableView: UITableView) -> Int {
        return 1
    }
}
extension ConversationsViewController {
    // Анимация заголовков тулбара
    func animateToolbarSubTitle(_ title: String) {
        UIView.animate(withDuration: 0.6, delay: 0, options: .transitionCrossDissolve, animations: {
            self.toolbar.detail = title
            self.toolbar.layoutIfNeeded()
        }, completion: { [weak self] _ in
            guard let self = self else { return }
            guard title == "Подключено" else { return }
            UIView.animate(withDuration: 0.6, delay: 0.6, options: .transitionCrossDissolve, animations: {
                self.toolbar.detail = ""
                self.toolbar.layoutIfNeeded()
            })
        })
    }
}
extension ConversationsViewController {
    // Проверка на присутствие биометрии
    var canEvaluatePolicy: Bool {
        return context.canEvaluatePolicy(.deviceOwnerAuthenticationWithBiometrics, error: nil)
    }
    
    // Аунтефикация пользователя по биометрии
    func authenticateUser(completion: @escaping () -> Void, failed: @escaping (String?) -> Void) { // 1
        guard canEvaluatePolicy else {
            failed("Face ID/Touch ID заблокирован")
            return
        }
        
        context.evaluatePolicy(.deviceOwnerAuthenticationWithBiometrics, localizedReason: "Доступ к скрытим перепискам") { (success, evaluateError) in
            if success {
                DispatchQueue.main.async {
                    completion()
                }
            } else {
                DispatchQueue.main.async {
                    let message: String
                    switch evaluateError {
                    case LAError.authenticationFailed?:
                     message = "Не удалось подтвердить вашу личность"
                    case LAError.userCancel?:
                     message = "Вы нажали отмену"
                    case LAError.userFallback?:
                     message = "Вы нажали \"пароль\""
                    case LAError.biometryNotAvailable?:
                     message = "Face ID/Touch ID недоступен"
                    case LAError.biometryNotEnrolled?:
                     message = "Face ID/Touch ID не настроен"
                    case LAError.biometryLockout?:
                     message = "Face ID/Touch ID заблокирован"
                    default:
                     message = "Face ID/Touch ID может быть не настроен"
                    }
                    failed(message)
                }
            }
        }
    }
}
extension ConversationsViewController: TextFieldDelegate {
    func textField(textField: TextField, didChange text: String?) {
        if textField.text == "" {
            UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
                self.searchController.clearButton.alpha = 0
                self.searchTable.alpha = 0
            }) { (isSuccess) in
                self.searchTable.isHidden = true
                self.searchController.clearButton.isHidden = true
            }
        } else {
            self.presenter?.onSearch(q: textField.text)
            self.searchController.clearButton.isHidden = false
            // self.searchTable.isHidden = false
            UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
                self.searchController.clearButton.alpha = 1
                self.searchTable.alpha = 1
            })
        }
    }
    
    func textFieldDidBeginEditing(_ textField: UITextField) {
        self.isSearch = true
        self.token = nil
        self.searchController.trailingConstraint?.constant = -104
        self.searchController.cancelButton.isHidden = false
        UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
            self.searchController.cancelButton.alpha = 1
            self.searchController.layoutIfNeeded()
        })
        NotificationCenter.default.post(name: NSNotification.Name(rawValue: "VKSearchBar.beginEditing"), object: nil)
    }
    
    func textFieldDidEndEditing(_ textField: UITextField) {
        self.isSearch = false
        self.observeConversations()
        self.searchController.trailingConstraint?.constant = -12
        self.searchController.textView.placeholderLabel.textColor = .adaptableDarkGrayVK
        UIView.animate(withDuration: 0.3, delay: 0, options: .transitionCrossDissolve, animations: {
            self.searchController.cancelButton.alpha = 0
            self.searchController.clearButton.alpha = 0
            self.searchController.layoutIfNeeded()
        }, completion: { _ in
            self.searchController.clearButton.isHidden = true
            self.searchController.cancelButton.isHidden = true
        })
        NotificationCenter.default.post(name: NSNotification.Name(rawValue: "VKSearchBar.endEditing"), object: nil)
    }
}
extension ConversationsViewController: MessageViewCellDelegate {
    func didTapName(cell: MessageViewCell, for name: String?) {
        print(name)
    }
}
extension ConversationsViewController: DropdownMenuDelegate {
    func dropdownMenu(_ dropdownMenu: DropdownMenu, didSelectRowAt indexPath: IndexPath) {
    }
}
